Proxmox/setup/homeassistant-install.sh

362 lines
11 KiB
Bash
Raw Normal View History

2022-04-25 17:09:58 +02:00
#!/usr/bin/env bash
2022-12-22 21:04:51 +01:00
if [ "$VERBOSE" == "yes" ]; then set -x; fi
2022-10-30 02:04:45 +01:00
YW=$(echo "\033[33m")
RD=$(echo "\033[01;31m")
BL=$(echo "\033[36m")
GN=$(echo "\033[1;92m")
CL=$(echo "\033[m")
2022-03-11 04:21:18 +01:00
RETRY_NUM=10
2022-02-23 12:54:52 +01:00
RETRY_EVERY=3
NUM=$RETRY_NUM
2022-04-16 17:18:00 +02:00
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
2022-04-25 17:09:58 +02:00
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
trap - ERR
Correct Spelling (#360) * Update adguard-install.sh * Update daemonsync-install.sh * Update dashy-install.sh * Update debian-install.sh * Update deconz-install.sh * Update docker-install.sh * Update esphome-install.sh * Update grafana-install.sh * Update heimdalldashboard-install.sh * Update homeassistant-install.sh * Update homebridge-install.sh * Update influxdb-install.sh * Update iobroker-install.sh * Update jellyfin-install.sh * Update keycloak-install.sh * Update magicmirror-install.sh * Update mariadb-install.sh * Update meshcentral-install.sh * Update motioneye-install.sh * Update mqtt-install.sh * Update nginx-proxy-manager-install.sh * Update nocodb-install.sh * Update node-red-install.sh * Update omada-install.sh * Update openhab-install.sh * Update photoprism-install.sh * Update pihole-install.sh * Update plex-install.sh * Update podman-homeassistant-install.sh * Update postgresql-install.sh * Update prometheus-install.sh * Update technitiumdns-install.sh * Update ubuntu-install.sh * Update unifi-install.sh * Update uptimekuma-install.sh * Update vaultwarden-install.sh * Update whoogle-install.sh * Update wireguard-install.sh * Update zigbee2mqtt-install.sh * Update zwavejs2mqtt-install.sh * Update adguard-v3.sh * Update create_lxc.sh * Update daemonsync-v3.sh * Update dashy-v3.sh * Update debian-v3.sh * Update deconz-v3.sh * Update docker-v3.sh * Update esphome-v3.sh * Update grafana-v3.sh * Update heimdalldashboard-v3.sh * Update homeassistant-v3.sh * Update homebridge-v3.sh * Update influxdb-v3.sh * Update iobroker-v3.sh * Update jellyfin-v3.sh * Update keycloak-v3.sh * Update magicmirror-v3.sh * Update mariadb-v3.sh * Update meshcentral-v3.sh * Update motioneye-v3.sh * Update mqtt-v3.sh * Update nginx-proxy-manager-v3.sh * Update nocodb-v3.sh * Update node-red-v3.sh * Update omada-v3.sh * Update openhab-v3.sh * Update photoprism-v3.sh * Update pihole-v3.sh * Update plex-v3.sh * Update podman-homeassistant-v3.sh * Update postgresql-v3.sh * Update prometheus-v3.sh * Update technitiumdns-v3.sh * Update ubuntu-v3.sh * Update unifi-v3.sh * Update uptimekuma-v3.sh * Update vaultwarden-v3.sh * Update whoogle-v3.sh * Update wireguard-v3.sh * Update zigbee2mqtt-v3.sh * Update zwavejs2mqtt-v3.sh
2022-07-20 12:10:39 +02:00
local reason="Unknown failure occurred."
2022-04-25 17:09:58 +02:00
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
}
2022-04-16 17:18:00 +02:00
function msg_info() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
2022-04-16 17:18:00 +02:00
}
function msg_ok() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
2022-04-16 17:18:00 +02:00
}
2022-02-23 12:54:52 +01:00
2022-08-31 11:20:58 +02:00
function msg_error() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -e "${BFR} ${CROSS} ${RD}${msg}${CL}"
2022-08-31 11:20:58 +02:00
}
2022-04-16 17:18:00 +02:00
msg_info "Setting up Container OS "
2022-02-23 12:54:52 +01:00
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
2022-10-30 02:04:45 +01:00
echo 1>&2 -en "${CROSS}${RD} No Network! "
2022-02-23 12:54:52 +01:00
sleep $RETRY_EVERY
((NUM--))
2022-10-30 02:04:45 +01:00
if [ $NUM -eq 0 ]; then
echo 1>&2 -e "${CROSS}${RD} No Network After $RETRY_NUM Tries${CL}"
2022-02-23 12:54:52 +01:00
exit 1
fi
done
2022-04-16 17:36:49 +02:00
msg_ok "Set up Container OS"
2022-04-16 17:18:00 +02:00
msg_ok "Network Connected: ${BL}$(hostname -I)"
2022-02-23 12:54:52 +01:00
2022-10-22 11:52:33 +02:00
set +e
alias die=''
2022-10-30 02:04:45 +01:00
if nc -zw1 8.8.8.8 443; then msg_ok "Internet Connected"; else
msg_error "Internet NOT Connected"
read -r -p "Would you like to continue anyway? <y/N> " prompt
if [[ $prompt == "y" || $prompt == "Y" || $prompt == "yes" || $prompt == "Yes" ]]; then
echo -e " ⚠️ ${RD}Expect Issues Without Internet${CL}"
else
echo -e " 🖧 Check Network Settings"
exit 1
fi
2022-10-30 02:04:45 +01:00
fi
2022-08-31 11:20:58 +02:00
RESOLVEDIP=$(nslookup "github.com" | awk -F':' '/^Address: / { matched = 1 } matched { print $2}' | xargs)
2022-10-30 02:04:45 +01:00
if [[ -z "$RESOLVEDIP" ]]; then msg_error "DNS Lookup Failure"; else msg_ok "DNS Resolved github.com to $RESOLVEDIP"; fi
2022-10-22 11:52:33 +02:00
alias die='EXIT=$? LINE=$LINENO error_exit'
set -e
2022-08-31 11:20:58 +02:00
2022-04-16 17:18:00 +02:00
msg_info "Updating Container OS"
2022-08-30 00:43:55 +02:00
apt-get update &>/dev/null
apt-get -y upgrade &>/dev/null
2022-04-16 17:36:49 +02:00
msg_ok "Updated Container OS"
2022-02-23 12:54:52 +01:00
2022-04-16 17:18:00 +02:00
msg_info "Installing Dependencies"
2022-02-23 12:54:52 +01:00
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
2022-04-16 17:36:49 +02:00
msg_ok "Installed Dependencies"
2022-02-23 12:54:52 +01:00
2022-04-16 17:18:00 +02:00
msg_info "Installing pip3"
2022-02-23 12:54:52 +01:00
apt-get install -y python3-pip &>/dev/null
2022-04-16 17:36:49 +02:00
msg_ok "Installed pip3"
2022-02-23 12:54:52 +01:00
2022-03-20 22:14:28 +01:00
get_latest_release() {
2022-10-30 02:04:45 +01:00
curl -sL https://api.github.com/repos/$1/releases/latest | grep '"tag_name":' | cut -d'"' -f4
2022-03-20 22:14:28 +01:00
}
DOCKER_LATEST_VERSION=$(get_latest_release "moby/moby")
CORE_LATEST_VERSION=$(get_latest_release "home-assistant/core")
PORTAINER_LATEST_VERSION=$(get_latest_release "portainer/portainer")
2022-04-16 17:18:00 +02:00
msg_info "Installing Docker $DOCKER_LATEST_VERSION"
2022-02-23 12:54:52 +01:00
DOCKER_CONFIG_PATH='/etc/docker/daemon.json'
mkdir -p $(dirname $DOCKER_CONFIG_PATH)
if [ "$ST" == "yes" ]; then
VER=$(curl -s https://api.github.com/repos/containers/fuse-overlayfs/releases/latest | grep "tag_name" | awk '{print substr($2, 2, length($2)-3) }')
cd /usr/local/bin
curl -sSL -o fuse-overlayfs https://github.com/containers/fuse-overlayfs/releases/download/$VER/fuse-overlayfs-x86_64
chmod 755 /usr/local/bin/fuse-overlayfs
cd ~
fi
2022-02-23 12:54:52 +01:00
cat >$DOCKER_CONFIG_PATH <<'EOF'
{
"log-driver": "journald"
}
EOF
sh <(curl -sSL https://get.docker.com) &>/dev/null
2022-04-16 17:36:49 +02:00
msg_ok "Installed Docker $DOCKER_LATEST_VERSION"
2022-02-23 12:54:52 +01:00
2022-04-16 17:18:00 +02:00
msg_info "Pulling Portainer $PORTAINER_LATEST_VERSION Image"
2022-02-23 12:54:52 +01:00
docker pull portainer/portainer-ce:latest &>/dev/null
2022-04-16 17:36:49 +02:00
msg_ok "Pulled Portainer $PORTAINER_LATEST_VERSION Image"
2022-02-23 12:54:52 +01:00
2022-04-16 17:18:00 +02:00
msg_info "Installing Portainer $PORTAINER_LATEST_VERSION"
2022-02-23 12:54:52 +01:00
docker volume create portainer_data >/dev/null
docker run -d \
-p 8000:8000 \
-p 9000:9000 \
--name=portainer \
--restart=always \
-v /var/run/docker.sock:/var/run/docker.sock \
-v portainer_data:/data \
portainer/portainer-ce:latest &>/dev/null
2022-04-16 17:36:49 +02:00
msg_ok "Installed Portainer $PORTAINER_LATEST_VERSION"
2022-02-23 12:54:52 +01:00
2022-04-16 17:18:00 +02:00
msg_info "Pulling Home Assistant $CORE_LATEST_VERSION Image"
2022-02-23 12:54:52 +01:00
docker pull homeassistant/home-assistant:stable &>/dev/null
2022-04-16 17:36:49 +02:00
msg_ok "Pulled Home Assistant $CORE_LATEST_VERSION Image"
2022-02-23 12:54:52 +01:00
2022-04-16 17:18:00 +02:00
msg_info "Installing Home Assistant $CORE_LATEST_VERSION"
2022-02-23 12:54:52 +01:00
docker volume create hass_config >/dev/null
docker run -d \
--name homeassistant \
--privileged \
--restart unless-stopped \
-v /var/run/docker.sock:/var/run/docker.sock \
-v /dev:/dev \
-v hass_config:/config \
-v /etc/localtime:/etc/localtime:ro \
--net=host \
homeassistant/home-assistant:stable &>/dev/null
2022-04-16 17:36:49 +02:00
msg_ok "Installed Home Assistant $CORE_LATEST_VERSION"
2022-02-23 12:54:52 +01:00
2022-04-16 17:18:00 +02:00
msg_info "Creating Update Menu Script"
2022-02-23 12:54:52 +01:00
pip3 install runlike &>/dev/null
UPDATE_PATH='/root/update'
UPDATE_CONTAINERS_PATH='/root/update-containers.sh'
cat >$UPDATE_PATH <<'EOF'
#!/bin/sh
set -o errexit
show_menu(){
normal=`echo "\033[m"`
safe=`echo "\033[32m"`
menu=`echo "\033[36m"`
number=`echo "\033[33m"`
bgred=`echo "\033[41m"`
fgred=`echo "\033[31m"`
hostname -I
printf "\n${menu}*********************************************${normal}\n"
printf "${menu}**${number} 1)${safe} Switch to Stable Branch ${normal}\n"
printf "${menu}**${number} 2)${number} Switch to Beta Branch ${normal}\n"
printf "${menu}**${number} 3)${fgred} Switch to Dev Branch ${normal}\n"
printf "${menu}**${number} 4)${safe} Backup Home Assistant Data (to root) ${normal}\n"
printf "${menu}**${number} 5)${number} Restore Home Assistant Data ${normal}\n"
printf "${menu}**${number} 6)${fgred} Edit Home Assistant Configuration ${normal}\n"
printf "${menu}**${number} 7)${safe} Restart Home Assistant ${normal}\n"
printf "${menu}**${number} 8)${safe} Just Update Containers ${normal}\n"
printf "${menu}**${number} 9)${number} Remove Unused Images ${normal}\n"
printf "${menu}**${number} 10)${safe} Update Host OS ${normal}\n"
printf "${menu}**${number} 11)${safe} Reboot Host OS ${normal}\n"
printf "${menu}*********************************************${normal}\n"
printf "Please choose an option from the menu and enter or ${fgred}x to exit. ${normal}"
read opt
}
option_picked(){
msgcolor=`echo "\033[01;31m"`
normal=`echo "\033[00;00m"`
message=${@:-"${normal}Error: No message passed"}
printf "${msgcolor}${message}${normal}\n"
}
clear
show_menu
while [ $opt != '' ]
do
if [ $opt = '' ]; then
exit;
else
case $opt in
1) clear;
option_picked "Switching to Stable Branch";
TAG=stable
break;
;;
2) clear;
option_picked "Switching to Beta Branch";
TAG=beta
break;
;;
3) while true; do
read -p "Are you sure you want to Switch to Dev Branch? Proceed(y/n)?" yn
case $yn in
[Yy]* ) break;;
[Nn]* ) exit;;
* ) echo "Please answer yes or no.";;
esac
done
clear;
option_picked "Switching to Dev Branch";
TAG=dev
break;
;;
4) clear;
option_picked "Backing up Home Assistant Data to root (hass_config)";
rm -r hass_config;
cp -pR /var/lib/docker/volumes/hass_config/ /root/;
2022-02-23 21:48:56 +01:00
sleep 2;
clear;
show_menu;
2022-02-23 12:54:52 +01:00
;;
5) while true; do
read -p "Are you sure you want to Restore Home Assistant Data? Proceed(y/n)?" yn
case $yn in
[Yy]* ) break;;
[Nn]* ) exit;;
* ) echo "Please answer yes or no.";;
esac
done
clear;
option_picked "Restoring Home Assistant Data from root (hass_config)";
rm -r /var/lib/docker/volumes/hass_config/_data;
cp -pR /root/hass_config/_data /var/lib/docker/volumes/hass_config/;
2022-02-23 21:48:56 +01:00
sleep 2;
clear;
show_menu;
2022-02-23 12:54:52 +01:00
;;
6) while true; do
read -p "Are you sure you want to Edit Home Assistant Configuration? Proceed(y/n)?" yn
case $yn in
[Yy]* ) break;;
[Nn]* ) exit;;
* ) echo "Please answer yes or no.";;
esac
done
clear;
option_picked "Editing Home Assistant Configuration";
nano /var/lib/docker/volumes/hass_config/_data/configuration.yaml;
2022-02-23 21:48:56 +01:00
clear;
show_menu;
2022-02-23 12:54:52 +01:00
;;
7) clear;
option_picked "Restarting Home Assistant";
docker restart homeassistant;
exit;
;;
8) clear;
option_picked "Just Updating Containers";
./update-containers.sh;
2022-02-23 21:48:56 +01:00
sleep 2;
clear;
show_menu;
2022-02-23 12:54:52 +01:00
;;
9) clear;
option_picked "Removing Unused Images";
docker image prune -af;
2022-02-23 21:48:56 +01:00
sleep 2;
clear;
show_menu;
2022-02-23 12:54:52 +01:00
;;
10) clear;
option_picked "Updating Host OS";
apt update && apt upgrade -y;
2022-02-23 21:48:56 +01:00
sleep 2;
clear;
show_menu;
2022-02-23 12:54:52 +01:00
;;
11) clear;
option_picked "Reboot Host OS";
reboot;
exit;
;;
x)exit;
;;
\n)exit;
;;
*)clear;
option_picked "Please choose an option from the menu";
show_menu;
;;
esac
fi
done
docker pull homeassistant/home-assistant:$TAG
docker rm --force homeassistant
docker run -d \
--name homeassistant \
--privileged \
--restart unless-stopped \
-v /var/run/docker.sock:/var/run/docker.sock \
-v /dev:/dev \
-v hass_config:/config \
-v /etc/localtime:/etc/localtime:ro \
-v /etc/timezone:/etc/timezone:ro \
--net=host \
homeassistant/home-assistant:$TAG
EOF
sudo chmod +x /root/update
cat >$UPDATE_CONTAINERS_PATH <<'EOF'
#!/bin/bash
set -o errexit
CONTAINER_LIST="${1:-$(docker ps -q)}"
for container in ${CONTAINER_LIST}; do
CONTAINER_IMAGE="$(docker inspect --format "{{.Config.Image}}" --type container ${container})"
RUNNING_IMAGE="$(docker inspect --format "{{.Image}}" --type container "${container}")"
docker pull "${CONTAINER_IMAGE}"
LATEST_IMAGE="$(docker inspect --format "{{.Id}}" --type image "${CONTAINER_IMAGE}")"
if [[ "${RUNNING_IMAGE}" != "${LATEST_IMAGE}" ]]; then
echo "Updating ${container} image ${CONTAINER_IMAGE}"
DOCKER_COMMAND="$(runlike "${container}")"
docker rm --force "${container}"
eval ${DOCKER_COMMAND}
fi
done
EOF
sudo chmod +x /root/update-containers.sh
2022-04-16 17:36:49 +02:00
msg_ok "Created Update Menu Script"
2022-02-23 20:05:56 +01:00
mkdir /root/hass_config
2022-10-30 02:04:45 +01:00
PASS=$(grep -w "root" /etc/shadow | cut -b6)
if [[ $PASS != $ ]]; then
msg_info "Customizing Container"
rm /etc/motd
rm /etc/update-motd.d/10-uname
touch ~/.hushlogin
GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $(dirname $GETTY_OVERRIDE)
cat <<EOF >$GETTY_OVERRIDE
2022-02-23 12:54:52 +01:00
[Service]
ExecStart=
ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
EOF
2022-10-30 02:04:45 +01:00
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
msg_ok "Customized Container"
fi
if [[ "${SSH_ROOT}" == "yes" ]]; then
2022-12-19 17:08:29 +01:00
sed -i "s/#PermitRootLogin prohibit-password/PermitRootLogin yes/g" /etc/ssh/sshd_config
systemctl restart sshd
fi
2022-02-23 12:54:52 +01:00
2022-04-16 17:36:49 +02:00
msg_info "Cleaning up"
2022-02-23 12:54:52 +01:00
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
2022-04-16 17:36:49 +02:00
msg_ok "Cleaned"